VERSION := 0.2.0

BIN_FILENAME = lander

BUILD_DIR      = build
SRC_DIR        = src
TEST_DIR       = test
THIRDPARTY_DIR = thirdparty

INC_DIRS  = include $(THIRDPARTY_DIR)/include lsm/include lnm/include ltm/include
LIBS      = lsm lnm ltm
LIB_DIRS  = ./lsm/build ./lnm/build ./ltm/build

# -MMD: generate a .d file for every source file. This file can be imported by
#  make and makes make aware that a header file has been changed, ensuring an
#  object file is also recompiled if only a header is changed.
# -MP: generate a dummy target for every header file (according to the  docs it
#  prevents some errors when removing header files)
CFLAGS ?= -MMD -MP -g -Wall

# When compiling release builds, these flags are better
# CLAGS = -O3
# LDFLAGS = -flto
