#include "lnm/loop_internal.h"

lnm_err lnm_loop_conn_init(lnm_loop_conn **out, lnm_loop *l) {
  lnm_loop_conn *conn = calloc(1, sizeof(lnm_loop_conn));

  if (conn == NULL) {
    return lnm_err_failed_alloc;
  }

  void *ctx;
  LNM_RES2(l->ctx_init(&ctx, l->gctx), free(conn));

  conn->ctx = ctx;
  *out = conn;

  return lnm_err_ok;
}

void lnm_loop_conn_free(lnm_loop *l, lnm_loop_conn *conn) {
  l->ctx_free(conn->ctx);
  free(conn);
}
