#ifndef LSM_TRIE_INTERNAL
#define LSM_TRIE_INTERNAL

#include "lsm/bt_internal.h"
#include "lsm/str_internal.h"
#include "lsm/trie.h"

struct lsm_trie_node {
  lsm_bt bt;
  lsm_str skip;
  void *data;
};

/**
 * Allocate and initialize a new trie node
 *
 * @param ptr pointer to store new node pointer
 */
lsm_error lsm_trie_node_init(lsm_trie_node **ptr);

/**
 * Deallocate a trie node
 *
 * @param node node to deallocate
 */
void lsm_trie_node_free(lsm_trie_node *node);

struct lsm_trie {
  lsm_trie_node *root;
  uint64_t size;
};

struct lsm_trie_iterator {
  lsm_trie_node *next;
  struct {
    lsm_bt_iterator *arr;
    size_t len;
    size_t cap;
  } stack;
};

#endif
